module MapFilter where

import Prelude hiding (map, filter)

map :: (alpha-> beta)-> [alpha]-> [beta]
map f = foldr ((:). f) []
-- map f = foldr (\a b-> f a: b) []

filter :: (alpha-> Bool)-> [alpha]-> [alpha]
filter p = foldr (\a as-> if p a then a:as 
                                 else as) []
