#include <stdlib.h>
#include <stdio.h>

#include "list.h"

void test1()
{
  int x = 7;
  list l1;

  l1= cons(&x, cons(&x, NULL));

  printf("Length: %d\n", length(l1));
}

void test2()
{
  int even(void *x) 
  {
    return (*(int *)x % 2 == 0);
  }
  void *dbl(void *x)
  {
    int *r;
    if ((r= (int *)malloc(sizeof(int)))== NULL) {
       printf("Out of memory\n"); exit(-1);
    }
    *r= *(int *)x*2;
    return r;
  }
  void prt(void *x) 
  {
    printf("%02d ", *(int *)x);
  }
  int x[] = { 1,8,3,6,5,4,7,2 };
  list l, l2;

  l= NULL;
  for (int i= 7; i>= 0; i--) {
    l= cons(&x[i], l);
  }
  printf("List 1: "); mapM_(prt, l); printf("\n");
  l= filter(even, l);
  printf("List (after filter): "); mapM_(prt, l); printf("\n");
  l2= map1(dbl, l);
  printf("List (applying map1): "); mapM_(prt, l); printf("\n");
  printf("Result of applying map1: "); mapM_(prt, l2); printf("\n");
  l= map2(dbl, l);
  printf("List 4 (applying map2): "); mapM_(prt, l); printf("\n");
  l= map3(dbl, l);
  printf("List 4 (applying map3): "); mapM_(prt, l); printf("\n");
}

int main(int argc, char *argv[])
{
  test1();
  test2();
  return 0;
}

